var wait_icon_html = '<span class="dashicons dashicons-update spin"></span>',
    tokens = [];

jQuery(document).ready(function() {
    jQuery('#accept_selected_books').prop('disabled', true);    
    jQuery('#delete_selected_books').prop('disabled', true);    

    jQuery('.booking_checkbox').change(function() {
        var count = jQuery('.booking_checkbox').filter(':checked').length;
        if (count > 0) {
            jQuery('#accept_selected_books').prop('disabled', false);
            jQuery('#delete_selected_books').prop('disabled', false);
        } else {
            jQuery('#accept_selected_books').prop('disabled', true);
            jQuery('#delete_selected_books').prop('disabled', true);
        }    
    });
});    

function book_an_appointment_961_toggleAll() {
    if ( jQuery('#select_all_books').prop('checked')) {
        jQuery('.booking_checkbox').prop('checked', true);
    } else {
        jQuery('.booking_checkbox').prop('checked', false);
    }    
    jQuery('.booking_checkbox:first').change();
}

function book_an_appointment_961_accept_book(item, token) {
    tokens = [];
    tokens.push(token);
    
    item.prepend(wait_icon_html);
    book_an_appointment_961_accept_books();
}

function book_an_appointment_961_delete_book(item, token) {
    tokens = [];
    tokens.push(token);

    item.prepend(wait_icon_html);
    book_an_appointment_961_delete_books_get_message();
}


function book_an_appointment_961_selected_tokens() {
    
    tokens = [];
    
    jQuery('.booking_checkbox').each(function() {
        if (this.checked) {
            tokens.push(jQuery(this).val());
        }
    });
    
    jQuery('#accept_selected_books').prepend(wait_icon_html);
    
    book_an_appointment_961_accept_books();
}

function book_an_appointment_961_delete_selected_tokens() {
    tokens = [];
    
    jQuery('.booking_checkbox').each(function() {
        if (this.checked) {
            tokens.push(jQuery(this).val());
        }
    });
    
    jQuery('#delete_selected_books').prepend(wait_icon_html);
    
    book_an_appointment_961_delete_books_get_message();
}



function book_an_appointment_961_accept_books() {

    var data = {
            action : 'book_an_appointment_961_accept_books',
            tokens : tokens
        };

    jQuery.ajax({
        url      : book_an_appointment_961_ajax_object.ajax_url,
        dataType : 'json',
        type     : 'POST',
        data     : data,
        success  : function(data, result){

            if (data.tokens != null) {
                data.tokens.forEach(function(token) {
                    jQuery('#unaccepted_bookings').find('[data-token="'+token+'"]').remove();
                });     
            }

            if (data.errors != null) {
                data.errors.forEach(function(error) {
                    console.log(error.token);
                    jQuery('#unaccepted_bookings')
                        .find('tr[data-token="'+error.token+'"]')
                        .find('.accept_function').html(error.message);                
                });     
            }

            if (data.status == 1) {

            } else {
                console.log(data);
            }
            jQuery('#unaccepted_bookings').find('.spin').remove();
        } 
    });
}

function book_an_appointment_961_delete_books() {

    var data = {
            action  : 'book_an_appointment_961_delete_books',
            tokens  : tokens,
            message : jQuery('#book_resignation_description').val()
        };

    jQuery.ajax({
        url      : book_an_appointment_961_ajax_object.ajax_url,
        dataType : 'json',
        type     : 'POST',
        data     : data,
        success  : function(data, result){

            if (data.tokens != null) {
                data.tokens.forEach(function(token) {
                    jQuery('#unaccepted_bookings').find('[data-token="'+token+'"]').remove();
                });     
            }
            jQuery('#unaccepted_bookings').find('.spin').remove();
        } 
    });
}

function book_an_appointment_961_delete_books_get_message() {
    
    book_an_appointment_961_showOverlay();
    
    var t = Math.floor((jQuery(window).height() - jQuery('#books_messageBox').height()) / 2);
    var l = Math.floor((jQuery(window).width() - jQuery('#books_messageBox').width()) / 2);
    jQuery('#books_messageBox').css('top', t + 'px');
    jQuery('#books_messageBox').css('left', l + 'px');
    jQuery('#books_messageBox').fadeIn();
    jQuery('#book_resignation_description').focus();
}

function book_an_appointment_961_action_cancel() {
    tokens = [];
    jQuery('#books_messageBox').hide();
    jQuery('#unaccepted_bookings').find('.spin').remove();
    book_an_appointment_961_hideOverlay();
}

function book_an_appointment_961_action_delete() {
    jQuery('#books_messageBox').hide();
    book_an_appointment_961_hideOverlay();
    book_an_appointment_961_delete_books();
}

function book_an_appointment_961_showOverlay() {
    var over = '<div id="overlay" class="overlay"></div>';
    jQuery('body').prepend(over);
    jQuery('#overlay').width( jQuery(window).width() );
    jQuery('#overlay').height( jQuery(window).height() );
    jQuery('#overlay').fadeIn(200);
}

function book_an_appointment_961_hideOverlay() {
    jQuery('#overlay').fadeOut(200);
    setTimeout(function() {
        jQuery('#overlay').remove();
    }, 250);    
}
