jQuery(document).ready(function() {
    
    jQuery('.booking-admin-icons').show();
    
    jQuery('.book_an_appointment_961_action_accept').on('click', function() {
    
        var token = jQuery(this).attr('data-token');
        
        jQuery(this).removeClass('dashicons-saved');
        jQuery(this).attr('data-action', 'accept');
        jQuery(this).addClass('dashicons-update-alt');
        jQuery(this).addClass('spin');
        
        var tokens = [];
        tokens.push(token);
        
        var data = {
                action : 'book_an_appointment_961_accept_books',
                tokens : tokens
            };
    
        jQuery.ajax({
            url      : book_an_appointment_961_ajax_object.ajax_url,
            dataType : 'json',
            type     : 'POST',
            data     : data,
            success  : function(data, result){
    
                if (data.status == 1) {
                    book_an_appointment_961_update_display();
                } else {
                    console.log(data);
                }
            } 
        });
        
    }); 

    jQuery('.book_an_appointment_961_action_show_delete_box').on('click', function() {
    
        var token = jQuery(this).attr('data-token');
        
        jQuery(this).removeClass('dashicons-trash');
        jQuery(this).attr('data-action', 'cancel');
        jQuery(this).addClass('dashicons-update-alt');
        jQuery(this).addClass('spin');

        book_an_appointment_961_showOverlay();
        
        jQuery('#book_resignation_token').val(token);
        var t = Math.floor((jQuery(window).height() - jQuery('#books_messageBox').height()) / 2);
        var l = Math.floor((jQuery(window).width() - jQuery('#books_messageBox').width()) / 2);
        jQuery('#books_messageBox').css('top', t + 'px');
        jQuery('#books_messageBox').css('left', l + 'px');
        jQuery('#books_messageBox').fadeIn();
        jQuery('#book_resignation_description').focus();
    }); 

    
});

function book_an_appointment_961_action_delete() {
    var tokens = [];
    tokens.push(jQuery('#book_resignation_token').val());
    var message = jQuery('#book_resignation_description').val();
    
    jQuery('#books_messageBox').hide();
    jQuery('#book_resignation_token').val('');
    book_an_appointment_961_hideOverlay();

    var data = {
            action  : 'book_an_appointment_961_delete_books',
            tokens  : tokens,
            message : message
        };

    jQuery.ajax({
        url      : book_an_appointment_961_ajax_object.ajax_url,
        dataType : 'json',
        type     : 'POST',
        data     : data,
        success  : function(data, result){

            if (data.tokens != null) {
                data.tokens.forEach(function(token) {
                    jQuery('.booking-table').find('[data-token="'+token+'"]').remove();
                });     
            } else {
                book_an_appointment_961_update_display();
            }
        } 
    });


}


function book_an_appointment_961_action_cancel() {
    jQuery('#books_messageBox').hide();
    jQuery('#book_resignation_token').val('');
    book_an_appointment_961_update_display();
    book_an_appointment_961_hideOverlay();
}


function book_an_appointment_961_showOverlay() {
    var over = '<div id="overlay" class="overlay"></div>';
    jQuery('body').prepend(over);
    jQuery('#overlay').width( jQuery(window).width() );
    jQuery('#overlay').height( jQuery(window).height() );
    jQuery('#overlay').fadeIn(200);
}

function book_an_appointment_961_hideOverlay() {
    jQuery('#overlay').fadeOut(200);
    setTimeout(function() {
        jQuery('#overlay').remove();
    }, 250);    
}


function book_an_appointment_961_update_display() {
    jQuery('.spin').each(function(){
        var action = jQuery(this).attr('data-action');
        switch (action){ 
        	case 'accept':
                jQuery(this).closest('.books-item')
                    .removeClass('booking-confirmed')
                    .addClass('booking-accepted');
                jQuery(this).fadeOut();
                break;
        
        	case 'cancel':
                jQuery(this).removeClass('dashicons-update-alt');
                jQuery(this).removeClass('spin');
                jQuery(this).addClass('dashicons-trash');
                break;

        	case 'delete':
                jQuery(this).closest('.booking-content').remove();
        	    break;
        
        	default :
                jQuery(this).removeClass('spin');
                jQuery(this).removeClass('dashicons-update-alt');
                jQuery(this).addClass( jQuery(this).attr('data-icon') );
                jQuery(this).removeAttr('data-icon');
        }
    });
}
