
jQuery(document).ready(function() {
	jQuery('[data-plugin]').each(function(){
		if (jQuery(this).attr('data-plugin') == 'book-an-appointment') {
            var token = jQuery(this).attr('data-token');
    		if (typeof token !== 'undefined' && token !== null) {
    			var variables = eval('book_an_appointment_variables_' + token);
    			book_an_appointment_961_draw_month(token, variables.now);
                book_an_appointment_961_setFruits(token);
    		}
		}
	});
});

jQuery('.appointment-form').submit (function() {
    var token = jQuery(this).closest('.book-an-appointment').attr('data-token');
    var days = [];
    jQuery('#book_an_appointment_'+token).find('.appointment-month').find('.on-select').each(function() {
        days.push( jQuery(this).attr('data-day') );
    });

    var form_data = {};
    jQuery('#book_an_appointment_'+token).find('.appointment-form').find('input').each(function(){
        var name = jQuery(this).attr('name');
        if (name.substr(0, 5) != 'fruit') { form_data[name] = jQuery(this).val(); }
    });    

    var data = {
            action   : 'book_an_appointment_961_save_appointment_function',
            id       : jQuery(this).closest('.book-an-appointment').attr('data-id'),
            days     : JSON.stringify(days),
            time     : jQuery('#book_an_appointment_'+token).find('.appointment-times').find('.on-select:first').attr('data-time'),
            data     : JSON.stringify(form_data),
            fruit    : jQuery('#fruit_name_'+token).val(),
            fruit_id : jQuery('#fruits_'+token).find('input[name="fruit"]:checked').val(),
            token    : token
        };

    var h = jQuery('#book_an_appointment_'+token).find('.appointment-form').height();
    jQuery('#book_an_appointment_'+token).find('.appointment-form').closest('div').height(h);
    jQuery('#book_an_appointment_'+token).find('.appointment-form').fadeOut(200);
    setTimeout(function(){
        jQuery('#book_an_appointment_'+token).find('.appointment-form').closest('div').prepend('<div class="book_an_appointment_wait"></div>');
    }, 210);

    jQuery.ajax({
        url      : book_an_appointment_961_ajax_object.ajax_url,
        dataType : 'json',
        type     : 'POST',
        data     : data,
        success  : function(data, result){
            jQuery('#book_an_appointment_'+data.token).find('.appointment-form').closest('div').find('.book_an_appointment_wait').remove();
            if (data.status == 1) {
                jQuery('#book_an_appointment_'+data.token).find('.appointment-form').html(data.html);
                jQuery('#book_an_appointment_'+data.token).find('.appointment-form').fadeIn(200);
            } else {
                jQuery('#book_an_appointment_'+data.token).find('.appointment-form').closest('div').prepend(data.html);
                setTimeout(function(){ 
                    jQuery('#book_an_appointment_'+data.token).find('.appointment-form').closest('div').find('.book_an_appointment_error').remove();
                    jQuery('#book_an_appointment_'+data.token).find('.appointment-form').fadeIn(200); 
                    book_an_appointment_961_setFruits(data.token);
                }, 5000);             
                if (data.time != '') {
                    jQuery('#book_an_appointment_'+data.token).find('.appointment-times').find('.on-select').remove();
                } else {
                    book_an_appointment_961_draw_month(data.token, data.month);
                }
                book_an_appointment_961_check_complete(data.token);   
            }
        },
        error: function (request, status, error) {
            alert('AJAX error : ' + status);
        } 
    });
    

    return false;
});

function book_an_appointment_961_setFruits(token) {
    var fruitID = Math.floor(Math.random() * form_fruits.length);

    // jQuery('#fruitName').html(dovi_form_fruits[fruitID]);
    jQuery('#robots-info_'+token).find('span').html(form_fruits[fruitID]);
    jQuery('#fruit_name_'+token).val(form_fruits[fruitID]);
    
    var fruits = []; 
    fruits.push(fruitID);
    var id = 0;
    do {
        id = Math.floor(Math.random() * form_fruits.length);
        if (!book_an_appointment_961_inArray(id, fruits)) {
            fruits.push(id);
        }
    }
    while (fruits.length <= 5);      
    book_an_appointment_961_shuffle(fruits);
    
    var html = '';
    for (i = 0; i < fruits.length; i++) { 
        html += '<div class="fruit_pic_items">' +
                '<img class="fruit_pic" src="'+fruits_url+fruits[i]+'.jpg" onclick="jQuery(this).closest(\'td\').find(\'.fruit'+fruits[i]+'\').prop(\'checked\', true);" /><br />'+
                '<input type="radio" name="fruit" class="fruit'+fruits[i]+'" value="'+(fruits[i]+1)+'" required />'+
                '</div>';
         
    }
    jQuery('#fruits_'+token).html(html);
}

function book_an_appointment_961_inArray(needle, haystack) {
    var length = haystack.length;
    for(var i = 0; i < length; i++) {
        if(typeof haystack[i] == 'object') {
            if(arrayCompare(haystack[i], needle)) {return true;}
        } else {
            if(haystack[i] == needle) {return true;}
        }
    }
    return false;
}    

function book_an_appointment_961_shuffle(array) {
    var counter = array.length;
    // While there are elements in the array
    while (counter > 0) {
        // Pick a random index
        var index = Math.floor(Math.random() * counter);
        // Decrease counter by 1
        counter--;
        // And swap the last element with it
        var temp = array[counter];
        array[counter] = array[index];
        array[index] = temp;
    }
    return array;
}


function book_an_appointment_961_set_month(item, now) {
    var token = item.closest('.book-an-appointment').attr('data-token');
    var appointment_id  = item.closest('.book-an-appointment').attr('data-id');

    if ( item.closest('.book-an-appointment').attr('data-events') == '1') {
        jQuery('#book_an_appointment_'+token).find('.appointment-month').fadeOut(200);
        setTimeout(function(){ 
            jQuery('#book_an_appointment_'+token).find('.appointment-month').html('<div class="book_an_appointment_wait"></div>');
            jQuery('#book_an_appointment_'+token).find('.appointment-month').show(); 
        }, 210);
    } else {
        item.html('<div class="book_an_appointment_wait_icon"></div>');
    }
    
    var variables = eval('book_an_appointment_variables_' + token);
    var data = {
            action : 'book_an_appointment_961_render_month',
            now     : now,
            id      : appointment_id,
            odd     : JSON.stringify(variables.odd),
            couple  : JSON.stringify(variables.couple),
            token   : token
        };
    jQuery.ajax({
        url      : book_an_appointment_961_ajax_object.ajax_url,
        dataType : 'json',
        type     : 'POST',
        data     : data,
        success  : function(data, result){
            if (data.status == 1) {
                // Status OK
                //jQuery('#book_an_appointment_'+token).find('.appointment-month').hide();
                if ( jQuery('#book_an_appointment_'+data.token).attr('data-events') == '1') {
                    jQuery('#book_an_appointment_'+data.token).find('.appointment-month').hide();
                    jQuery('#book_an_appointment_'+data.token).find('.appointment-month').html(data.html);
                    jQuery('#book_an_appointment_'+data.token).find('.appointment-month').fadeIn();
                } else {
                    jQuery('.book_an_appointment_wait_icon').remove();
                    jQuery('#book_an_appointment_'+data.token).find('.appointment-month').append(data.html);
                }
            } else {
                console.log(data);
            }
        },
        error: function (request, status, error) {
            alert('AJAX error : ' + status);
        } 
    });

}

function book_an_appointment_961_draw_month(token, now) {

    var variables = eval('book_an_appointment_variables_' + token);

    var data = {
            action  : 'book_an_appointment_961_draw_month_function',
            now     : now,
            id      : jQuery('#book_an_appointment_'+token).attr('data-id'),
            odd     : JSON.stringify(variables.odd),
            couple  : JSON.stringify(variables.couple),
            token   : token
        };

    jQuery.ajax({
        url      : book_an_appointment_961_ajax_object.ajax_url,
        dataType : 'json',
        type     : 'POST',
        data     : data,
        success  : function(data, result){
            jQuery('#book_an_appointment_'+data.token).find('.appointment-times').html('');
            if (data.status == 1) {
                // Status OK
                jQuery('#book_an_appointment_'+data.token).find('.appointment-month').html(data.html);
                jQuery('#book_an_appointment_'+data.token).attr('data-events', data.show_events);
                
            } else {
                console.log(data);
            }
        },
        error: function (request, status, error) {
            alert('AJAX error : ' + status);
        } 
    });
}

function book_an_appointment_961_on_select(item) {

    if ( item.closest('.book-an-appointment').attr('data-events') != '1') {
        if (item.hasClass('on-select')) {
            item.removeClass('on-select');
        } else {
            item.addClass('on-select');
        }
    } else {
        item.closest('.appointment-month').find('.on-select').removeClass('on-select');
        item.addClass('on-select');      
        book_an_appointment_961_show_times(item.attr('data-day'), item.closest('.book-an-appointment').attr('data-token'));  
    }
    book_an_appointment_961_check_complete(item.closest('.book-an-appointment').attr('data-token'));
}

function book_an_appointment_961_show_times(day, token) {

    jQuery('#book_an_appointment_'+token).find('.appointment-times').html('<div class="book_an_appointment_wait_icon"></div>');
    var variables = eval('book_an_appointment_variables_' + token);
    
    var data = {
            action  : 'book_an_appointment_961_show_times_function',
            day     : day,
            odd     : JSON.stringify(variables.odd),
            couple  : JSON.stringify(variables.couple),
            id      : jQuery('#book_an_appointment_'+token).attr('data-id'),
            token   : token
        };
    jQuery.ajax({
        url      : book_an_appointment_961_ajax_object.ajax_url,
        dataType : 'json',
        type     : 'POST',
        data     : data,
        success  : function(data, result){
            if (data.status == 1) {
                // Status OK
                jQuery('#book_an_appointment_'+data.token).find('.appointment-times').html(data.html);
                
            } else {
                console.log(data);
            }
        },
        error: function (request, status, error) {
            alert('AJAX error : ' + status);
        } 
    });
}

function book_an_appointment_961_on_select_time(item) {
    item.closest('.appointment-times').find('.on-select').removeClass('on-select');
    item.addClass('on-select');  
    book_an_appointment_961_check_complete(item.closest('.book-an-appointment').attr('data-token'));    
}

function book_an_appointment_961_check_complete(token) {
    var complete = true;
    var days = jQuery('#book_an_appointment_'+token).find('.appointment-month').find('.on-select');
    if (days.length < 1) {
        complete = false;
    }   
    if ( jQuery('#book_an_appointment_'+token).attr('data-events') == '1') {
        var times = jQuery('#book_an_appointment_'+token).find('.appointment-times').find('.on-select');
        if (times.length < 1) {
            complete = false;
        }   
    }
    
    if (complete) {
        jQuery('#book_an_appointment_'+token).find('.booking_button').prop('disabled', false);        
    } else {
        jQuery('#book_an_appointment_'+token).find('.booking_button').prop('disabled', true);
    }
}

function book_an_appointment_961_call_ajax_sample(token, data) {

    var data = {
            action : 'book_an_appointment_961_call_ajax_function',
            variables : data,
            token     : token
        };

    jQuery.ajax({
        url      : book_an_appointment_961_ajax_object.ajax_url,
        dataType : 'json',
        type     : 'POST',
        data     : data,
        success  : function(data, result){
            if (data.status == 1) {
                // Status OK
                jQuery('#book_an_appointment_'+data.token).find('.appointment-mont').html(data.html);
            } else {
                console.log(data);
            }
        },
        error: function (request, status, error) {
            alert('AJAX error : ' + status);
        } 
    });
}

