<?php

// If required and available duplicate post function
if (file_exists(dirname(__file__) . '/duplicate.php')) {
    require_once( dirname(__file__) . '/duplicate.php' );
}


// If required and available custom meta box
if (file_exists(dirname(__file__) . '/custom-meta-box/custom-meta-box.php')) {

    if ( ! function_exists( 'book_an_appointment_961_init_custom_box_place' ) ) {
        function book_an_appointment_961_init_custom_box_place() {
        
            require_once( dirname(__file__) . '/custom-meta-box/custom-meta-box.php' );
            $config = array(
                    'id'     => 'custom_meta_box',
                    // 'context'  => 'normal',            
                    // 'priority' => 'high',    
                    // 'meta_key' => 'custom',
                    'title'  => __('Place properties', 'book-an-appointment'),
                    'pages'  => array('booking-place'),         // array('post', 'page')
                    'fields' => array() 
                );
                
            $custom_meta_box = new Dovi42_Appointment_Meta_Box($config);    
            $custom_meta_box
                ->addField(
                        array(
                            'id'    => 'on_days',
                            'type'  => 'checkbox',
                            'label' => __('Allow booking on business days.', 'book-an-appointment'),
                        ));
            $custom_meta_box
                ->addField(
                        array(
                            'id'    => 'on_weekends',
                            'type'  => 'checkbox',
                            'label' => __('Allow booking on weekends.', 'book-an-appointment'),
                        ));
            $custom_meta_box
                ->addField(
                        array(
                            'id'    => 'on_holidays',
                            'type'  => 'checkbox',
                            'label' => __('Allow booking on public holidays.', 'book-an-appointment'),
                        ));
            $custom_meta_box
                ->addField(
                        array(
                            'id'     => 'reservation',
                            'type'   => 'radio',
                            'label'  => __('Reservation type:', 'book-an-appointment'),
                            'values' => array(
                                'day'   => __('Full day', 'book-an-appointment'),
                                'time'  => __('Time point', 'book-an-appointment')
                            )
                        ));
            $custom_meta_box
                ->addField(
                        array(
                            'id'    => 'mins',
                            'type'  => 'number',
                            'label' => __('Minute period:', 'book-an-appointment'),
                            'description' => __('Minute in one reservation.', 'book-an-appointment')
                        ));
            $custom_meta_box
                ->addField(
                        array(
                            'id'     => 'reserved',
                            'type'   => 'text',
                            'label' => __('Reserved times:', 'book-an-appointment'),
                            'description' => __('Taken times separated by commas. <small><em>(eg 12:00,12:30)</em></small>', 'book-an-appointment')
                        ));
            $custom_meta_box
                ->addField(
                        array(
                            'id'     => 'disabled',
                            'type'   => 'textarea',
                            'label' => __('Disabled days:', 'book-an-appointment'),
                            'description' => __('Days that cannot be booked.<br />Taken dates separated by commas. <small><em>(eg 2020-09-21,2020-09-22)</em></small>', 'book-an-appointment')
                        ));
            $custom_meta_box
                ->addField(
                        array(
                            'id'    => 'shift',
                            'type'  => 'number',
                            'label' => __('Shift days(s):', 'book-an-appointment'),
                            'description' => __('You can book no earlier than this many days.', 'book-an-appointment')
                        ));
            $custom_meta_box
                ->addField(
                        array(
                            'id'     => 'emails',
                            'type'   => 'text',
                            'label' => __('Notifications:', 'book-an-appointment'),
                            'description' => __('Sends a notification of confirmed bookings to these recipients.<br /><small>Comma-separated email address list. If left blank, no notification will be sent.</small>', 'book-an-appointment')
                        ));

            $custom_meta_box
                ->addField(
                        array(
                            'id'     => 'managers',
                            'type'   => 'usergroups',
                            'label' => __('Manager groups:', 'book-an-appointment'),
                            'description' => __('Select manager(s) in group lists.', 'book-an-appointment')
                        ));

            $custom_meta_box
                ->addField(
                        array(
                            'id'     => 'manager',
                            'type'   => 'userlist',
                            'label' => __('Manage user:', 'book-an-appointment'),
                            'description' => __('Select user for managed in frontend.', 'book-an-appointment')
                        ));

            $config = array(
                    'id'     => 'couple_meta_box',
                    'context'  => 'side',            
                    'priority' => 'default',    
                    // 'meta_key' => 'custom',
                    'title'  => __('In a couple of weeks', 'book-an-appointment'),
                    'pages'  => array('booking-place'),         // array('post', 'page')
                    'fields' => array() 
                );
                
            $couple_meta_box = new Dovi42_Appointment_Meta_Box($config);    
            $couple_meta_box
                ->addField(
                        array(
                            'id'    => 'couple_on_time',
                            'type'  => 'time',
                            'label' => __('On time:', 'book-an-appointment'),
                        ));
            $couple_meta_box
                ->addField(
                        array(
                            'id'    => 'couple_off_time',
                            'type'  => 'time',
                            'label' => __('Off time:', 'book-an-appointment'),
                        ));

            $config['id'] = 'odd_meta_box';
            $config['title'] = __('An odd weeks', 'book-an-appointment');
            $odd_meta_box = new Dovi42_Appointment_Meta_Box($config);    
            $odd_meta_box
                ->addField(
                        array(
                            'id'    => 'odd_on_time',
                            'type'  => 'time',
                            'label' => __('On time:', 'book-an-appointment'),
                        ));
            $odd_meta_box
                ->addField(
                        array(
                            'id'    => 'odd_off_time',
                            'type'  => 'time',
                            'label' => __('Off time:', 'book-an-appointment'),
                        ));
            
                        
        }
        add_action( 'plugins_loaded', 'book_an_appointment_961_init_custom_box_place' );
    }
}