<?php
if (!class_exists('JDovi42Templates')) {
    include_once(dirname(__file__) .DIRECTORY_SEPARATOR. 'jdovi42_templates.php');
}

function book_an_appointment_961_render_month_table($month, $id, $times) {
    
    global $wpdb;
    
    $options = book_an_appointment_961_get_options();
    $html = '<table data-month="'.$month.'"><caption>'.date_i18n($options['date_format'], strtotime($month.'-01')).'</caption>'.'<thead><tr>';
    $start_of_week = get_option( 'start_of_week' );
    $days = array(
        __('Su', 'book-an-appointment'),
        __('Mo', 'book-an-appointment'),
        __('Tu', 'book-an-appointment'),
        __('We', 'book-an-appointment'),
        __('Th', 'book-an-appointment'),
        __('Fr', 'book-an-appointment'),
        __('Sa', 'book-an-appointment'));
    for ($i = $start_of_week; $i <= 6; $i++) {
    	$html .= '<th>'.__($days[$i]).'</th>';
    }
    for ($i = 0; $i < $start_of_week; $i++) {
    	$html .= '<th>'.__($days[$i]).'</th>';
    }
    $html .= '</tr></thead><tbody><tr>';
    
    $col = 1;
    $first = date('N', strtotime($month.'-01'));
    $days = date('t', strtotime($month.'-01'));
    for ($i = 0; $i < ($first - $start_of_week); $i++) {
    	$html .= '<td>'.'&nbsp;'.'</td>';
        $col++;
    }

    $shift = get_post_meta($id, 'appointment_shift', true);
    if ($shift == '0') { $shift = ''; }
    if (!empty($shift)) {
        $now = date('Y-m-d', strtotime('+'.$shift.' day'));
    } else {
        $now = date('Y-m-d');
    }
    
    $on_works    = get_post_meta($id, 'appointment_on_days', true);
    $on_weekends = get_post_meta($id, 'appointment_on_weekends', true);
    $on_holidays = get_post_meta($id, 'appointment_on_holidays', true);
    $on_disabled = get_post_meta($id, 'appointment_disabled', true);
    $on_disabled = str_replace(' ', '', $on_disabled);
    $on_disabled = explode(',', $on_disabled);
    $type = get_post_meta($id, 'appointment_reservation', true);

    $holidays = explode(',', str_replace(' ', '', $options['holiday']));
    $works    = explode(',', str_replace(' ', '', $options['work']));    
    $weekends = explode(',', str_replace(' ', '', $options['free']));

    for ($i = 1; $i <= $days; $i++) {

        $class = array();
        $script = '';
        $d = $i;
        if ($d < 10) { $d = '0'.$d; }
        
        $actual = $month . '-' . $d;
        
        if (date('Y-m-d') == $actual) {
            $class[] = 'now';
        }
        if ($now > $actual) {
            if (!in_array('disabled', $class)) {
                $class[] = 'disabled';
            }
        }

        // Check the holiday
        if (in_array($actual, $holidays)) {
            $class[] = 'holiday';  
            if ($on_holidays != '1') {
                if (!in_array('disabled', $class)) {
                    $class[] = 'disabled';
                }
            } 
        }
        
        // Check the weekend
        $is_weekend = false;
        if (in_array($actual, $weekends)) {
            $is_weekend = true;
        } else {
            $n = date('N', strtotime($actual));
            if ($n > 5) {
                if (!in_array($actual, $works)) {
                    $is_weekend = true;
                }
            }            
        }
        if ($is_weekend) {
            $class[] = 'weekend';   
            if ($on_weekends != '1') {
                if (!in_array('disabled', $class)) {
                    $class[] = 'disabled';
                }
            } 
        }
        
        // Check the business day
        $is_business = false;
        if (in_array($actual, $works)) {
            $is_business = true;
        } else {
            $n = date('N', strtotime($actual));
            if ($n <= 5) {
                if (!in_array($actual, $weekends)) {
                    if (!in_array($actual, $holidays)) {
                        $is_business = true;
                    }
                }
            }            
        }
        if ($is_business) {
            if ($on_works != '1') {
                if (!in_array('disabled', $class)) {
                    $class[] = 'disabled';
                }
            } 
        }

        // Check the disabled
        if (in_array($actual, $on_disabled)) {
            $class[] = 'disabled';            
        }

        // Check is Free (or free time count)
        if (!in_array('disabled', $class)) {
            
            if ($type != 'time') {
                $query = 'SELECT COUNT(id) FROM ' . $wpdb->prefix.'bookanappointment ' .
                            'WHERE ' . 
                                '`place_id` = "'.$id.'" AND ' .
                                '`date` = "'.$month.'-'.$d.'"';
                $count = $wpdb->get_var($query);
                if ($count > 0) {
                    $class[] = 'disabled';    
                }
            } else {

                $w = date('W', strtotime($month.'-'.$d));
                if ($w % 2 == 0) {
                    $times_list = $times['couple'];
                } else {
                    $times_list = $times['odd'];
                }
                if (date('Y-m-d') == $month.'-'.$d) {
                    $index_time = date_i18n('H:i');
                    $query = 'SELECT COUNT(id) FROM ' . $wpdb->prefix.'bookanappointment ' .
                                'WHERE ' . 
                                    '`place_id` = "'.$id.'" AND ' .
                                    '`date` = "'.$month.'-'.$d.'" AND ' .
                                    '`time` > "'.$index_time.'"';
                    $now_times = array();
                    foreach ($times_list as $time) {
                        if ($time > $index_time) {
                            $now_times[] = $time;
                        }
                    }
                    $times_list = $now_times;
                } else {
                    $query = 'SELECT COUNT(id) FROM ' . $wpdb->prefix.'bookanappointment ' .
                                'WHERE ' . 
                                    '`place_id` = "'.$id.'" AND ' .
                                    '`date` = "'.$month.'-'.$d.'"';
                }
                $count = $wpdb->get_var($query);
                if ($count >= count($times_list)) {
                    $class[] = 'disabled';    
                }
            }
        }        
        
        if (!in_array('disabled', $class)) {
            $class[] = 'selectable';
            $script = 'onclick="book_an_appointment_961_on_select(jQuery(this))"';
        }

    	$html .= '<td class="'.implode(' ', $class).'" '.$script.' data-day="'.$month.'-'.$d.'">'.$i.'</td>';
        $col++;
        if ($col > 7) {
            $html .= '</tr><tr>';
            $col = 1;
        }
    }
    for ($i = $col; $i <= 7; $i++) {
    	$html .= '<td>'.'&nbsp;'.'</td>';
    }
    
    $html .= '</tr></tbody>';
    
    $mode = get_post_meta($id, 'appointment_reservation', true);
    $prev_html = '';
    if (($mode == 'time') and ($month > date('Y-m'))) {
        $prev = date('Y-m', strtotime('-1 month', strtotime($month.'-01')));
        $prev_html = '<div class="prev_month" onclick="book_an_appointment_961_set_month(jQuery(this), \''.$prev.'\');"><span class="dashicons dashicons-arrow-left"></span>'.date_i18n('F', strtotime($prev)).'</div>';        
    }
    
    $next = date('Y-m', strtotime('+1 month', strtotime($month.'-01')));
    $html .= '<tfoot><tr><td colspan="7">'.
              $prev_html .
             '<div class="next_month" onclick="book_an_appointment_961_set_month(jQuery(this), \''.$next.'\');">'.date_i18n('F', strtotime($next)).'<span class="dashicons dashicons-arrow-right"></span></div>'.
             '</td></tr></tfoot>';
    
    $html .= '</table>';
    
    return $html;
}

function book_an_appointment_961_render_month() {
    $data = array();
    foreach ($_REQUEST as $key => $value) {
       $data[sanitize_text_field($key)] = sanitize_text_field($value);
    }

    $odd = sanitize_text_field($_REQUEST['odd']);
    $odd = json_decode(html_entity_decode( stripslashes($odd)));

    $couple = sanitize_text_field($_REQUEST['couple']);
    $couple = json_decode(html_entity_decode( stripslashes ($couple)));

    $times = array(
            'odd'    => $odd,
            'couple' => $couple
        );

    $html = book_an_appointment_961_render_month_table($data['now'], $data['id'], $times);

    $result = array(
        'status' => 1,
        'html'   => $html,
        'token'  => $data['token'],
        'now'    => $data['now']
    );
    echo json_encode($result);
    wp_die();
}
add_action( 'wp_ajax_nopriv_book_an_appointment_961_render_month', 'book_an_appointment_961_render_month' );
add_action( 'wp_ajax_book_an_appointment_961_render_month', 'book_an_appointment_961_render_month' );


function book_an_appointment_961_draw_month_function() {
    $data = array();
    foreach ($_REQUEST as $key => $value) {
       $data[sanitize_text_field($key)] = sanitize_text_field($value);
    }

    $odd = sanitize_text_field($_REQUEST['odd']);
    $odd = json_decode(html_entity_decode( stripslashes($odd)));

    $couple = sanitize_text_field($_REQUEST['couple']);
    $couple = json_decode(html_entity_decode( stripslashes ($couple)));

    $times = array(
            'odd'    => $odd,
            'couple' => $couple
        );

    $data['show_events'] = 0;
    $html = '';
    
    if (!empty($data['id'])) {
        $type = get_post_meta($data['id'], 'appointment_reservation', true);
        if ($type == 'time') {
            $data['show_events'] = 1;
        }
        $html = book_an_appointment_961_render_month_table($data['now'], $data['id'], $times);
    } else {
        $html = '<div class="alert alert-danger" role="alert">' .
                __('There is no such reservation place.', 'book-an-appointment') .
                '</div>';
    }
    
    $result = array(
        'status' => 1,
        'html'   => $html,
        'token'  => $data['token'],
        'now'    => $data['now'],
        'id'     => $data['id'],
        'show_events' => $data['show_events']
    );
    echo json_encode($result);
    wp_die();

}
add_action( 'wp_ajax_nopriv_book_an_appointment_961_draw_month_function', 'book_an_appointment_961_draw_month_function' );
add_action( 'wp_ajax_book_an_appointment_961_draw_month_function', 'book_an_appointment_961_draw_month_function' );

function book_an_appointment_961_show_times_function() {

    global $wpdb;

    $day   = sanitize_text_field($_REQUEST['day']);
    $id    = sanitize_text_field($_REQUEST['id']);
    $token = sanitize_text_field($_REQUEST['token']);
    
    $odd = sanitize_text_field($_REQUEST['odd']);
    $odd = json_decode(html_entity_decode( stripslashes($odd)));

    $couple = sanitize_text_field($_REQUEST['couple']);
    $couple = json_decode(html_entity_decode( stripslashes ($couple)));
    
    $w = date('W', strtotime($day));
    if ($w % 2 == 0) {
        $times = $couple;
    } else {
        $times = $odd;
    }

    $query = 'SELECT `time` FROM ' . $wpdb->prefix.'bookanappointment ' .
                'WHERE ' . 
                    '`place_id` = "'.$id.'" AND ' .
                    '`date` = "'.$day.'"';
    $reserved = $wpdb->get_col(
                    $wpdb->prepare($query, 'time'));

    $now = '';
    if ($day == date_i18n('Y-m-d')) {
        $now = date_i18n('H:i');
    }

    foreach ($times as $time) {
        if ($now < $time) {
            if (!in_array($time, $reserved)) {
                $html .= '<div onclick="book_an_appointment_961_on_select_time(jQuery(this));" class="appointment-time" data-time="'.$time.'">'.$time.'</div>';
            }
        }
    }

    if (empty($html)) {
        $html = '<div class="alert alert-warning" role="alert">'.__('<strong>Sorry!</strong> There are no more appointments for this day.','book-an-appointment').'</div>';
    }

    $result = array(
        'status' => 1,
        'html'   => $html,
        'token'  => $token
    );
    echo json_encode($result);
    wp_die();
}
add_action( 'wp_ajax_nopriv_book_an_appointment_961_show_times_function', 'book_an_appointment_961_show_times_function' );
add_action( 'wp_ajax_book_an_appointment_961_show_times_function', 'book_an_appointment_961_show_times_function' );

function book_an_appointment_961_save_appointment_function() {

    global $wpdb;

    $token = sanitize_text_field($_REQUEST['token']);
    $date = json_decode(html_entity_decode( stripslashes( sanitize_text_field($_REQUEST['days']) )));
    
    $fruitName  = sanitize_text_field($_REQUEST['fruit']);
    $fruitID    = sanitize_text_field($_REQUEST['fruit_id']);
    if ($fruitID == 0) { $fruitName = null; } else { $fruitID--; }
    
    $fruits = explode('|', __('apple|banana|blackberry|cherry|orange|pear|plum|raspberry|strawberry|lemon|peach|grapes|apricot|watermelon|coconut|melon|pineapple|kiwi', 'book-an-appointment'));
    if (($fruitName == null) or ($fruitName != $fruits[$fruitID])) {

        $html = '<div class="book_an_appointment_error alert alert-danger" role="alert">' .
                __('<strong>Error checking robot!</strong> The selected fruit is not suitable.', 'book-an-appointment').
                '</div>';


        $data = array(
            'status' => 0,
            'html'   => $html,
            'time'   => '', 
            'month'  => substr($date[0], 0, 7),
            'token'  => $token
        );
        echo json_encode($data);
        wp_die();
        
    }

    $id   = sanitize_text_field($_REQUEST['id']);
    $time = '';
    if (isset($_REQUEST['time'])) {
        $time = sanitize_text_field($_REQUEST['time']);
    }
    $data = json_decode(html_entity_decode( stripslashes( sanitize_text_field($_REQUEST['data']) )), true);

    $type = get_post_meta($id, 'appointment_reservation', true);
    $month = '';
    if ($type == 'time') {
        $date = $date[0];

        $query = 'SELECT COUNT(id) AS count FROM ' . $wpdb->prefix.'bookanappointment ' .
                    'WHERE ' . 
                        '`place_id` = "'.$id.'" AND ' .
                        '`date` = "'.$date.'" AND ' .
                        '`time` = "'.$time.':00"';
        $result = $wpdb->get_results($query);
        $count = $result[0]->count;
        if ($count > 0) {
            $status = 0;
            $html = '<div class="book_an_appointment_error alert alert-warning" role="alert">' .
                    __('<strong>We are sorry!</strong> The date has meanwhile been booked by someone else.', 'book-an-appointment').
                    '</div>';
        } else {

            $url_token = book_an_appointment_961_generate_token();

            $wpdb->insert($wpdb->prefix.'bookanappointment',
                array(
                    'place_id' => $id,
                    'date'     => $date,
                    'time'     => $time,
                    'ip'       => book_an_appointment_961_get_IP_address(),
                    'token'    => $url_token,
                    'data'     => serialize($data)
                )
            );
            if ($wpdb->last_error != '') {
                $time = '';
                $status = 0;
                $html = '<div class="book_an_appointment_error alert alert-danger" role="alert">' .
                        htmlspecialchars( $wpdb->last_result, ENT_QUOTES ) .
                        '</div>';
            } else {
                $status = 1;
                $html = '<div class="alert alert-success" role="alert">' .
                        __('<strong>Thank You!</strong> The booking has been recorded and an email has been sent to you to confirm to the address provided.<br /><small>Remember to also check your spam folder!</small>', 'book-an-appointment') .
                        '</div>';
                $error = book_an_appointment_961_send_mail($id, $date, $time, $data, $url_token);
                if ($error != '') {
                    $html = $error;
                }                        
            }
        }
        
    } else {
        $query = 'SELECT COUNT(id) AS count FROM ' . $wpdb->prefix.'bookanappointment ' .
                    'WHERE ' . 
                        '`place_id` = "'.$id.'" AND ' .
                        '`date` IN ("'.implode('","', $date).'")';
        $result = $wpdb->get_results($query);
        $count = $result[0]->count;

        if ($count > 0) {
            $status = 0;
            $html = '<div class="book_an_appointment_error alert alert-warning" role="alert">' .
                    __('<strong>We are sorry!</strong> The date has meanwhile been booked by someone else.', 'book-an-appointment').
                    '</div>';
            $month = substr($date[0], 0, 7);
        } else {

            $url_token = book_an_appointment_961_generate_token();
            $ip = book_an_appointment_961_get_IP_address();
            $errors = array();
            foreach ($date as $item) {
                $wpdb->insert($wpdb->prefix.'bookanappointment',
                    array(
                        'place_id' => $id,
                        'date'     => $item,
                        'ip'       => $ip,
                        'token'    => $url_token,
                        'data'     => serialize($data)
                    )
                );
                if ($wpdb->last_error != '') {
                    $errors[] = '<div class="book_an_appointment_error alert alert-danger" role="alert">' .
                                  htmlspecialchars( $wpdb->last_result, ENT_QUOTES ) .
                                '</div>';
                }                
            }
            if (!empty($errors)) {
                $html = implode('', $errors);
                $time = '';
                $status = 0;
            } else {
                $status = 1;
                $html = '<div class="alert alert-success" role="alert">' .
                        __('<strong>Thank You!</strong> The booking has been recorded and an email has been sent to you to confirm to the address provided.<br /><small>Remember to also check your spam folder!</small>', 'book-an-appointment') .
                        '</div>';
                $error = book_an_appointment_961_send_mail($id, $date, $time, $data, $url_token);
                if ($error != '') {
                    $html = $error;
                }                        
            }
        }
    }

    $result = array(
        'status' => $status,
        'html'   => $html,
        'time'   => $time,
        'month'  => $month,
        'token'  => $token
    );
    echo json_encode($result);
    wp_die();
}
add_action( 'wp_ajax_nopriv_book_an_appointment_961_save_appointment_function', 'book_an_appointment_961_save_appointment_function' );
add_action( 'wp_ajax_book_an_appointment_961_save_appointment_function', 'book_an_appointment_961_save_appointment_function' );

function book_an_appointment_961_generate_token()
{

    $chars = 'ABCDEFGHIJKLMNOPQURSTXYVWZ0123456789';
    $token = array();
    for ($j = 0; $j <= 4; $j++) {
        $token[$j] = '';
        for ($i = 1; $i <= 4; $i++) {
        	$token[$j] .= substr($chars, rand(0, strlen($chars)-1), 1);
        }                
    }
    $token = implode('-', $token);
    return $token;
}


function book_an_appointment_961_send_mail($post_id, $days, $time, $data, $token) {
    
    if (isset($data['email'])) {
        
        $headers = array('Content-Type: text/html; charset=UTF-8');
        $subject = __('Booking confirmation', 'book-an-appointment');
        
        $data['link_confirmation'] = get_home_url().'/booking-confirmation/'.$token;
        $data['link_cancel'] = get_home_url().'/booking-cancel/'.$token;
        $data['title'] = get_the_title($post_id);
        
        $data['description'] = book_an_appointment_961_get_excerpt($post_id);
        
        if (!is_array($days)) {
            $data['day'] = date_i18n('Y. F j., l,', strtotime($days));
            $data['time'] = date_i18n('H:i', strtotime($time));
            $data['days'] = '';
        } else {
            $data['day'] = '';
            $data['days'] = array();
            foreach ($days as $day) {
                $data['days'][] = array('day' => date_i18n('Y. F j., l,', strtotime($day)));    
            }
        }
        
        $lang = book_an_appointment_961_get_lang();
        $data['template'] = 'emails' .DIRECTORY_SEPARATOR. $lang .DIRECTORY_SEPARATOR. 'confirmation-user.html';
        $tmpl = new JDovi42Templates($data);
        $body = $tmpl->prepareContent();
        
        if ($body == '') {
            return '';
        }
        
        if ( wp_mail($data['email'], $subject, $body, $headers) ) {
            return '';
        } else {
            return '<div class="book_an_appointment_error alert alert-danger" role="alert">' .
                   __('Error sending email', 'book-an-appointment') .
                   '</div>';
        }
    }
    return '<div class="book_an_appointment_error alert alert-danger" role="alert">' .
           __('No email address set!', 'book-an-appointment') .
           '</div>';
}

function book_an_appointment_961_get_IP_address()
{
    foreach (array('HTTP_CLIENT_IP',
                   'HTTP_X_FORWARDED_FOR',
                   'HTTP_X_FORWARDED',
                   'HTTP_X_CLUSTER_CLIENT_IP',
                   'HTTP_FORWARDED_FOR',
                   'HTTP_FORWARDED',
                   'REMOTE_ADDR') as $key){
        if (array_key_exists($key, $_SERVER) === true){
            foreach (explode(',', $_SERVER[$key]) as $IPaddress){
                $IPaddress = trim($IPaddress); // Just to be safe
                if (filter_var($IPaddress,
                               FILTER_VALIDATE_IP,
                               FILTER_FLAG_NO_PRIV_RANGE | FILTER_FLAG_NO_RES_RANGE)
                    !== false) {

                    return $IPaddress;
                }
            }
            return $IPaddress;
        }
    }
}

function book_an_appointment_961_accept_books() {
    
    global $wpdb;    
    
    $tokens = isset( $_REQUEST['tokens'] ) ? (array) $_REQUEST['tokens'] : array();
    $tokens = array_map( 'esc_attr', $tokens );

    $errors = array();
    $status = 1;

    foreach ($tokens as $token) {

        $sql = 'SELECT *'.
               ' FROM ' . $wpdb->prefix . 'bookanappointment' . 
               ' WHERE `token` = "'.$token.'"' .
               ' ORDER BY `id` DESC';
        $items = $wpdb -> get_results($sql);

        if (empty($items)) {
            $status = 0;
            $errors[] = array(
                            'token'   => $token,
                            'message' => __('Token not found', 'book-an-appointment')
                        ); 
            $tokens = array_diff($tokens, $token);           
        } else {
            $data = unserialize($items[0]->data);
            $email = $data['email'];
            
            if ((isset($email)) and (!empty($email))) {

                $headers = array('Content-Type: text/html; charset=UTF-8');
                $subject = __('Booking accepted confirmation', 'book-an-appointment');
                
                if (!is_array($items)) {
                    $data['day'] = date_i18n('Y. F j., l,', strtotime($items[0]->date));
                    $data['time'] = date_i18n('H:i', strtotime($items[0]->time));
                    $data['days'] = '';
                } else {
                    $data['day'] = '';
                    $data['days'] = array();
                    foreach ($items as $item) {
                        $data['days'][] = array('day' => date_i18n('Y. F j., l,', strtotime($item->date)));    
                    }
                }

                $data['title'] = get_the_title($items[0]->place_id);
                $data['description'] = book_an_appointment_961_get_excerpt($items[0]->place_id);
                $data['link_cancel'] = get_home_url().'/booking-cancel/'.$items[0]->token;


                $lang = book_an_appointment_961_get_lang();
                $data['template'] = 'emails' .DIRECTORY_SEPARATOR. $lang .DIRECTORY_SEPARATOR. 'accept-admin.html';
                $tmpl = new JDovi42Templates($data);
                $body = $tmpl->prepareContent();

                if ($body != '') {
                    if ( !wp_mail($email, $subject, $body, $headers) ) {

                        $status = 0;
                        $errors[] = array(
                                        'token'   => $token,
                                        'message' => __('Error sending email', 'book-an-appointment')
                                    ); 
                        $tokens = array_diff($tokens, $token);           
                    } else {
                        $wpdb->update($wpdb->prefix.'bookanappointment',
                                array('accept' => date_i18n('Y-m-d H:i:s')),
                                array('token' => $token) 
                            );
                    }
                }
                
            } else {
                $status = 0;
                $errors[] = array(
                                'token'   => $token,
                                'message' => __('Email not found', 'book-an-appointment')
                            );
                $tokens = array_diff($tokens, $token);            
            }
        }
        
        
    }

    $result = array(
        'status' => $status,
        'tokens' => $tokens,
        'errors' => $errors
    );
    echo json_encode($result);
    wp_die();
}
add_action( 'wp_ajax_nopriv_book_an_appointment_961_accept_books', 'book_an_appointment_961_accept_books' );
add_action( 'wp_ajax_book_an_appointment_961_accept_books', 'book_an_appointment_961_accept_books' );

function book_an_appointment_961_delete_books() {
    
    global $wpdb;    
    
    $tokens = isset( $_REQUEST['tokens'] ) ? (array) $_REQUEST['tokens'] : array();
    $tokens = array_map( 'esc_attr', $tokens );

    $message = '';
    if (isset($_REQUEST['message'])) {
        $message = sanitize_text_field($_REQUEST['message']);
    }

    $status = 1;

    foreach ($tokens as $token) {

        $sql = 'SELECT *'.
               ' FROM ' . $wpdb->prefix . 'bookanappointment' . 
               ' WHERE `token` = "'.$token.'"' .
               ' ORDER BY `id` DESC';
        $items = $wpdb -> get_results($sql);
        
        if (!empty($items)) {

            $data = unserialize($items[0]->data);
            $email = $data['email'];
            $data['message'] = $message;
            
            if ((isset($email)) and (!empty($email))) {

                $headers = array('Content-Type: text/html; charset=UTF-8');
                $subject = __('Booking cancellation', 'book-an-appointment');
                
                if (!is_array($items)) {
                    $data['day'] = date_i18n('Y. F j., l,', strtotime($items[0]->date));
                    $data['time'] = date_i18n('H:i', strtotime($items[0]->time));
                    $data['days'] = '';
                } else {
                    $data['day'] = '';
                    $data['days'] = array();
                    foreach ($items as $item) {
                        $data['days'][] = array('day' => date_i18n('Y. F j., l,', strtotime($item->date)));    
                    }
                }

                $data['title'] = get_the_title($items[0]->place_id);
                $data['description'] = book_an_appointment_961_get_excerpt($items[0]->place_id);

                $lang = book_an_appointment_961_get_lang();
                $data['template'] = 'emails' .DIRECTORY_SEPARATOR. $lang .DIRECTORY_SEPARATOR. 'cancelled-admin.html';
                $tmpl = new JDovi42Templates($data);
                $body = $tmpl->prepareContent();
                if ($body != '') {
                    wp_mail($email, $subject, $body, $headers);
                } 
            }
            $wpdb->delete(
                    $wpdb->prefix.'bookanappointment',
                    array('token' => $token) 
                );
        }

    }

    $result = array(
        'status' => $status,
        'tokens' => $tokens
    );
    echo json_encode($result);
    wp_die();
}
add_action( 'wp_ajax_nopriv_book_an_appointment_961_delete_books', 'book_an_appointment_961_delete_books' );
add_action( 'wp_ajax_book_an_appointment_961_delete_books', 'book_an_appointment_961_delete_books' );

