<?php 
    get_header(); 
    
    global $dovi42_cpt_name, $dovi42_cpt_category_name;
    
    $post_id = get_the_ID();
    $step  = get_post_meta($post_id, 'appointment_mins', true);
    $type = get_post_meta($post_id, 'appointment_reservation', true);
?>
<style>
    .booking-table {
        width: 100%;
        margin-bottom: 15px;
    }
    .booking-table {
        table-layout: fixed;
    }
    .booking-table td,
    .booking-table th {
        font-size: 13px;
        padding: 6px;
    	border: 1px solid #ccc;
        table-layout: fixed;
        vertical-align: top;
    }
    .booking-table th {
        border-bottom: 3px solid #ccc;
        font-weight: normal;
    }
    .booking-table tfoot tr {
    	border-top: 3px solid #ccc;
    }
    .booking-time {
    	width: 6%;
    	text-align: center;
    }
    .bg-white {
        background-color: #FFFFFF;
    }
    .booking-confirmed,
    .booking-accepted,
    .booking-pending {
        margin: 3px;
        padding: 4px;
        border-radius: 6px;
    }
    .booking-accepted {
        border: 1px solid rgba(50,205,50, 1);
        background-color: rgba(50,205,50, .1);
    }
    .booking-confirmed {
        border: 1px solid rgba(44,130,201, 1);
        background-color: rgba(255,255,224, .5);
    }
    .booking-pending {
        border: 1px solid rgba(100,100,100, 1);
        background-color: rgba(200,200,200, .2);
        opacity: .5;
    }
    .booking-reserved {
        background-color: rgba(220,20,60, .1);
    }
    .booking-legend .booking-accepted,
    .booking-legend .booking-confirmed,
    .booking-legend .booking-pending,
    .booking-legend .booking-reserved {
    	padding: 0 8px;
    }
    .booking-legend {
        font-size: 90%;
        border: 1px solid #ccc;
        border-radius: 6px;
        padding:10px;
    }
    td.no-border {
        border: none;
    }
    .calendar-day {
        color: #FFFFFF;
        background-color: rgba(0,0,0,.3);
        padding: 0px 4px;
        border-radius: 4px;
        display: inline-block;
        float: left;
        font-weight: bold;
    }
    th.calendar-dayname {
        text-align: right;
        font-weight: bold;
    }
    .holiday .calendar-day,
    th.holiday {
        color: white;
        background-color: red;
    }
    .weekend {
        background-color: rgba(255,255,128, .2);
    }
</style>

<div class="<?php echo get_theme_mod('theme_page_width', 'container');?> pt-3 page">
    <div class="row">
        <div class="col-sm">
            <div id="content" role="main">
            <?php
               
                if ($type == 'time') {
                    include( dirname(__file__) . '/single-booking-place-admin-week.php');
                } else {
                    include( dirname(__file__) . '/single-booking-place-admin-month.php');
                }

                $legends = array();
                $legends[] = '<span class="booking-reserved">&nbsp;</span>&nbsp;' . __('Reserved', 'book-an-appointment');
                $legends[] = '<span class="booking-pending">&nbsp;</span>&nbsp;' . __('User confirmation pending', 'book-an-appointment');
                $legends[] = '<span class="booking-confirmed">&nbsp;</span>&nbsp;' . __('User confirmed', 'book-an-appointment');
                $legends[] = '<span class="booking-accepted">&nbsp;</span>&nbsp;' . __('Admin accepted', 'book-an-appointment');
                
                echo '<div class="booking-legend">' .
                        implode('&nbsp;&nbsp;|&nbsp;&nbsp;', $legends) .
                     '</div>';
            ?>
            
            </div><!-- /#content -->
        </div>
    </div><!-- /.row -->
</div><!-- /#page -->

<?php get_footer(); ?>
